"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const result_1 = tslib_1.__importDefault(require("./result"));
const context_1 = require("./uitls/context");
function createMockFunction(funcs, funcName) {
    const mockFuncs = { ...funcs };
    const createRunner = (args = null) => (injectContext) => {
        Object.keys(funcs).forEach((k) => {
            if (funcName !== k)
                mockFuncs[k] = jest.fn();
        });
        const context = Object.assign({}, context_1.createBaseContext(), mockFuncs, injectContext);
        const returnVal = funcs[funcName].apply(context, args ? args : []);
        return new result_1.default(returnVal, context);
    };
    const targetMockFunc = (...args) => {
        return {
            run: createRunner(args),
            r: createRunner(args)
        };
    };
    targetMockFunc.run = targetMockFunc.r = createRunner();
    return targetMockFunc;
}
function watch(component) {
    var _a, _b;
    if (typeof component !== 'object' && typeof component !== 'function') {
        throw new Error('Illegal component. component must be object or function.');
    }
    const watchers = component.options
        ? component.options.watch // VueConstructor
        : (_a = component) === null || _a === void 0 ? void 0 : _a.watch; // Not VueConstructor
    if (!watchers)
        throw new Error('Not exists watcher.');
    let methods = component.options
        ? component.options.methods // VueConstructor
        : (_b = component) === null || _b === void 0 ? void 0 : _b.methods; // Not VueConstructor
    if (!methods)
        methods = {};
    const mockWatchers = {};
    Object.keys(watchers).forEach((key) => {
        mockWatchers[key] = createMockFunction({ ...watchers, ...methods }, key);
    });
    return mockWatchers;
}
exports.default = watch;
